// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('starter', ['ionic', 'ionic-native-transitions', 'ngSanitize', 'ngStorage', 'ngCordova', 'gu.route', 'gu.service', 'gu.directive', 'gu.controller', 'gu.constant'])

    .config(function($ionicConfigProvider) {
        $ionicConfigProvider.tabs.position('bottom');
        /*$ionicConfigProvider.views.maxCache(10);
         /*$ionicConfigProvider.views.forwardCache(false);*/
    })

    .config(function($ionicNativeTransitionsProvider){
        $ionicNativeTransitionsProvider.setDefaultOptions({
            duration: 400, // in milliseconds (ms), default 400,
            slowdownfactor: 4, // overlap views (higher number is more) or no overlap (1), default 4
            iosdelay: 50, // ms to wait for the iOS webview to update before animation kicks in, default -1
            androiddelay: -1, // same as above but for Android, default -1
            winphonedelay: -1, // same as above but for Windows Phone, default -1,
            fixedPixelsTop: 0, // the number of pixels of your fixed header, default 0 (iOS and Android)
            fixedPixelsBottom: 0, // the number of pixels of your fixed footer (f.i. a tab bar), default 0 (iOS and Android)
            triggerTransitionEvent: '$ionicView.afterEnter', // internal ionic-native-transitions option
            backInOppositeDirection: true // Takes over default back transition and state back transition to use the opposite direction transition to go back
        });
        $ionicNativeTransitionsProvider.setDefaultTransition({
            type: 'slide',
            direction: 'left'
        });
    })

    .run(function($ionicPlatform, $rootScope, $ionicHistory, $cordovaSQLite, $location, $state, $timeout) {
        $ionicPlatform.ready(function() {
            console.log('设备就绪');
            if (window.cordova && window.cordova.plugins.Keyboard) {
                // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
                // for form inputs)
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);

                // Don't remove this line unless you know what you are doing. It stops the viewport
                // from snapping when text inputs are focused. Ionic handles this internally for
                // a much nicer keyboard experience.
                cordova.plugins.Keyboard.disableScroll(true);
            }
            if (window.StatusBar) {
                StatusBar.styleDefault();
            }
            $rootScope.wxInstalled = false;
            $timeout(function () {
                if (window.Wechat) {
                    Wechat.isInstalled(function (installed) {
                        $rootScope.wxInstalled = !!installed;
                    });
                }
            }, 500);
        });

        $ionicPlatform.registerBackButtonAction(function(e) {
            var rootStates = ['focus', 'journal', 'user'];
            console.log($location.path());
            if ($rootScope.backButtonPressedOnceToExit) {
                ionic.Platform.exitApp();
            } else if (rootStates.indexOf($ionicHistory.currentView().stateName) != -1) {
                $ionicHistory.nextViewOptions({
                    historyRoot: true
                });
                $state.go('home');
            } else if ($ionicHistory.backView()) {
                $rootScope.$ionicGoBack();
            } else {
                $rootScope.backButtonPressedOnceToExit = true;
                window.plugins.toast.showShortBottom(
                    "再按一次退出系统",
                    function(a) {},
                    function(b) {}
                );
                setTimeout(function() {
                    $rootScope.backButtonPressedOnceToExit = false;
                }, 2000);
            }
            e.preventDefault();
            return false;
        }, 101);

    })
    .run(function($rootScope, $state, $ionicHistory, AuthService, ModalService) {
        $rootScope.$on('$stateChangeStart', function(event, next, nextParams, from) {
            console.log('fromState.name: '+from.name);
            console.log('toState.name: '+next.name);
            if (next.name == 'focus' || next.name == 'user-focus' || next.name == 'user-heart' || next.name == 'user-like') {
                if (! AuthService.isAuthenticated()) {
                    event.preventDefault();
                    ModalService.loginModal.open($rootScope.login);
                    return;
                }
            }
            switch (next.name) {
                case 'home':
                case 'focus':
                case 'journal':
                case 'user':
                    $rootScope.tabSelected = next.name;
                    break;
            }
        })
    })
