angular
.module('gu.controller')
.controller('FocusCtrl', function($scope, $rootScope, $state, $ionicHistory, $ionicLoading, AuthService, ModalService, ApiService) {
  console.log('关注页');
  $scope.data = {
    topNews: [],
    loadingFinished: false,

    pageNo: 1,
    totalPage: 1,
    totalCount: 0,
    journalCount: 0,
    focusedJournals: []

  };

  $rootScope.$on('FOCUS_CLICKED', function(event, data) {
    if (data.addFlag) {
      $scope.data.journalCount++;
      /*ApiService
        .loadTopNewsOfJournal({
          journalID: data.journalID
        })
        .then(function(response) {
          $scope.data.topNews.push(response.data.topNews);
        })
        .catch(function(error) {})*/
    } else {
      $scope.data.journalCount--;

      for (var index = $scope.data.topNews.length - 1; index >= 0; index--)
        if ($scope.data.topNews[index].journal.JID == data.journalID) {
          $scope.data.topNews[index].journal.focuses_count --;
          $scope.data.topNews.splice(index, 1);
        }
    }
  });

  $rootScope.$on('LIKE_CLICKED', function(event, data) {
    for (var index = 0; index < $scope.data.topNews.length; index++) {
      if ($scope.data.topNews[index].Nid == data.newsID)
        break;
    }

    if (index < $scope.data.topNews.length) {
      if (data.addFlag) {
        $scope.data.topNews[index].likes_count ++;
      } else {
        $scope.data.topNews[index].likes_count --;
      }
    }
  })

  $scope.doRefresh = function() {
    console.log('上啦刷新');
    init();
    $scope.$broadcast('scroll.refreshComplete');
  };


  $scope.loadMore = function() {
      ApiService
        .loadTopNewsOfFocusedJournals({
          pageNo: $scope.data.pageNo + 1
        })
        .then(function (response) {
          $scope.data.pageNo = response.data.pageNo;
          $scope.data.totalCount = response.data.total;
          $scope.data.totalPage = response.data.totalPage;
          $scope.data.journalCount = response.data.journalCount;
          for (var i = 0; i < response.data.topNews.length; i++) {
            $scope.data.topNews.push(response.data.topNews[i]);
          }
        })


      .catch(function(error) {
        if (error.status == 401) { // 已过期， 从新登陆
          AuthService
            .tokenExpired()
            .then(function() {
              ModalService.loginModal.open($rootScope.login);
            })
        }
      })
      .finally(function() {
        $ionicLoading.hide();
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })

  }

  function init() {
    loadFocusedJournals();
    loadTopNewsOfFocusedJournals();
  }

  init();

    function loadFocusedJournals() {
      $scope.data.loadingFinished = false;
      $ionicLoading.show({
        template: '加载中...',
        showBackdrop: true,
      });
      ApiService
        .loadFocusedJournals({
          pageNo: 1
        })
        .then(function(response) {
          $scope.data.focusedJournals = response.data.focusedJournals;
          $scope.data.totalPage = response.data.totalPage;
          $scope.data.pageNo = response.data.pageNo;
        })
        .catch(function(error) {
          if (error.status == 401) { // 已过期， 从新登陆
            AuthService
              .tokenExpired()
              .then(function() {
                ModalService.loginModal.open($rootScope.login);
              })
          }
        })
        .finally(function() {
          $scope.data.loadingFinished = true;
          $ionicLoading.hide();
        })
    }

  function loadTopNewsOfFocusedJournals() {
    $scope.data.loadingFinished = false;
    $ionicLoading.show({
      template: '加载中...',
      showBackdrop: true,
    });
    ApiService
      .loadTopNewsOfFocusedJournals({
        pageNo: 1
      })
      .then(function(response) {
        $scope.data.topNews = response.data.topNews;
        $scope.data.pageNo = response.data.pageNo;
        $scope.data.totalCount = response.data.total;
        $scope.data.totalPage = response.data.totalPage;
        $scope.data.journalCount = response.data.journalCount;
      })
      .catch(function(error) {
        if (error.status == 401) { // 已过期， 从新登陆
          AuthService
            .tokenExpired()
            .then(function() {
              ModalService.loginModal.open($rootScope.login);
            })
        }
      })
      .finally(function() {
        $scope.data.loadingFinished = true;
        $ionicLoading.hide();
      })
  }
})

