angular
.module('gu.controller')
.controller('HomeCtrl', function($scope, $rootScope, $state, $location, $ionicHistory, $ionicLoading, $ionicScrollDelegate, LocalService, ApiService) {
  console.log('首页');
  $scope.data = {
    categoryIndex: -1,
    categories: [],
    topNews: [],

    keyword: '',
    totalPage: 1,
    pageNo: 1
  }

  $rootScope.$on('FOCUS_CLICKED', function(event, data) {
    for (var index = 0; index < $scope.data.topNews.length; index++) {
      if ($scope.data.topNews[index].journal.JID == data.journalID) {
        if (data.addFlag) {
          $scope.data.topNews[index].journal.focuses_count ++;
        } else {
          $scope.data.topNews[index].journal.focuses_count --;
        }
      }
    }
  });

  $rootScope.$on('LIKE_CLICKED', function(event, data) {
    for (var index = 0; index < $scope.data.topNews.length; index++) {
      if ($scope.data.topNews[index].Nid == data.newsID)
        break;
    }

    if (index < $scope.data.topNews.length) {
      if (data.addFlag) {
        $scope.data.topNews[index].likes_count ++;
      } else {
        $scope.data.topNews[index].likes_count --;
      }
    }
  })

    $scope.search = function() {
      if (! $scope.data.keyword) return;
      $state.go('search', {keyword: $scope.data.keyword});
      $scope.data.keyword = '';
    }

  $scope.doRefresh = function() {
    init();
    $scope.$broadcast('scroll.refreshComplete');
  };

  $scope.changeCategory = function(index) {
    if ($scope.data.categoryIndex == index) {
      return;
    }
    $scope.data.categoryIndex = index;
    if (index <= 2) {
      $ionicScrollDelegate.$getByHandle('homeCategoryScroll').scrollTop();
    } else {
      $location.hash('home-category-' + (index - 2));
      $ionicScrollDelegate.$getByHandle('homeCategoryScroll').anchorScroll(true);
    }
    loadTopNews();
  }

  $scope.loadMore = function() {
    var categoryID = currentCategoryID();
    ApiService
      .loadAllTopNews({
        pageNo: $scope.data.pageNo + 1,
        categoryID: categoryID
      })
      .then(function(response) {
        $scope.data.totalPage = response.data.totalPage;
        $scope.data.pageNo = response.data.pageNo;

        for (var i = 0; i < response.data.news.length; i++) {
          var topNews = response.data.news[i];
          $scope.data.topNews.push(topNews);
        }
      })
      .catch(function(response) {
      })
      .finally(function() {
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })
  }


  init();

  function init() {
    loadCategory();
    loadTopNews();
  }

  function loadTopNews() {
    var categoryID = currentCategoryID();

    $ionicLoading.show({
      template: '加载中...',
      showBackdrop: true,
    });
    ApiService
      .loadAllTopNews({
        pageNo: 1,
        categoryID: categoryID
      })
      .then(function(response) {
        $scope.data.totalPage = response.data.totalPage;
        $scope.data.pageNo = response.data.pageNo;
        $scope.data.topNews = response.data.news;
      })
      .catch(function(error) {
      })
      .finally(function() {
        $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        $ionicLoading.hide();
      });
  }

  function loadCategory() {
    ApiService
      .loadCategories()
      .then(function(response) {
        var categories = response.data;
        if (! categories.length) {
          $ionicLoading.hide();
          return;
        }
        LocalService
          .storeCategories(categories)
          .then(function(response) {
            $scope.data.categories = categories;
          })
          .catch(function(error) {
            //alert(JSON.stringify(error));
          })
      })
      .catch(function(error) {
        //alert("2:" + JSON.stringify(error));
      });
  }

  function currentCategoryID() {
    return ($scope.data.categoryIndex == -1) ? 0 : $scope.data.categories[$scope.data.categoryIndex].sid;
  }
})
