angular
.module('gu.controller')
.controller('JournalCategoryCtrl', function($scope, $rootScope, $state, $ionicHistory, $timeout, $location, $ionicLoading, $stateParams, $ionicScrollDelegate, LocalService, ApiService) {
  console.log('小刊分类页');
  $scope.data = {
    categoryIndex: $stateParams.index,
    categories: LocalService.categories(),
    journals: [],

    totalPage: 1,
    pageNo: 1
  };

  $scope.goBack = function() {
    $rootScope.$ionicGoBack();;
  }

  $rootScope.$on('FOCUS_CLICKED', function(event, data) {
    for (var index = 0; index < $scope.data.journals.length; index++) {
      if ($scope.data.journals[index].JID == data.journalID)
        break;
    }

    if (index < $scope.data.journals.length) {
      if (data.addFlag) {
        $scope.data.journals[index].focuses_count ++;
      } else {
        $scope.data.journals[index].focuses_count --;
      }
    }
  });

  $scope.doRefresh = function() {
    init();
    $scope.$broadcast('scroll.refreshComplete');
  };

  $scope.loadMoreJournals = function() {
    ApiService
      .loadJournalsByCategory({
        categoryID: $scope.data.categories[$scope.data.categoryIndex].sid,
        pageNo: $scope.data.pageNo + 1
      })
      .then(function(response) {
        $scope.data.totalPage = response.data.totalPage;
        $scope.data.pageNo = response.data.pageNo;

        for (var i = 0; i < response.data.journals.length; i++) {
          $scope.data.journals.push(response.data.journals[i]);
        }
      })
      .catch(function(error) {
      })
      .finally(function() {
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })
  }

  $scope.changeCategory = function(index) {
    $scope.data.categoryIndex = index;

    init();
  }

  function init() {
    if ($scope.data.categoryIndex <= 2) {
      $ionicScrollDelegate.$getByHandle('categoryScroll').scrollTop();
    } else {
      $location.hash('category-' + ($scope.data.categoryIndex - 2));
      $ionicScrollDelegate.$getByHandle('categoryScroll').anchorScroll(true);
    }
    $ionicLoading.show({
      template: '加载中...',
      showBackdrop: true,
    });
    ApiService
      .loadJournalsByCategory({
        categoryID: $scope.data.categories[$scope.data.categoryIndex].sid,
        pageNo: 1
      })
      .then(function(response) {
        $scope.data.totalPage = response.data.totalPage;
        $scope.data.pageNo = response.data.pageNo;
        $scope.data.journals = response.data.journals;
      })
      .catch(function(error) {
      })
      .finally(function() {
        $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        $ionicLoading.hide();
      })
  }

  $scope.$on('$ionicView.beforeEnter', function(event, data) {
    init();
  })
})
