angular
.module('gu.controller')
.controller('JournalCtrl', function($scope, $rootScope, $state, $ionicHistory, $ionicScrollDelegate, $location, $ionicLoading, LocalService, ApiService) {
  console.log('小刊页');
  $scope.data = {
    categories: LocalService.categories(),
    latestNews: {},
    recentJournals: [],
    keyword: '',

    totalPage: 1,
    pageNo: 1
  };

  $rootScope.$on('FOCUS_CLICKED', function(event, data) {
    for (var index = 0; index < $scope.data.recentJournals.length; index++) {
      if ($scope.data.recentJournals[index].JID == data.journalID)
        break;
    }
    if (index < $scope.data.recentJournals.length) {
      if (data.addFlag) {
        $scope.data.recentJournals[index].focuses_count ++;
      } else {
        $scope.data.recentJournals[index].focuses_count --;
      }
    }
  });

  $scope.doRefresh = function() {
    console.log('上啦刷新');
    init();
    $scope.$broadcast('scroll.refreshComplete');
  };

  $scope.search = function() {
    if (! $scope.data.keyword) return;
    $state.go('search', {keyword: $scope.data.keyword});
    $scope.data.keyword = '';
  }

  $scope.loadMoreJournals = function() {
    ApiService
      .loadRecentJournals({
        pageNo: $scope.data.pageNo + 1
      })
      .then(function(response) {
        $scope.data.totalPage = response.data.totalPage;
        $scope.data.pageNo = response.data.pageNo;

        for (var i = 0; i < response.data.journals.length; i++) {
          var journal = response.data.journals[i];
          $scope.data.recentJournals.push(journal);
        }
      })
      .catch(function(response) {
      })
      .finally(function() {
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })
  }

  init();

  function init() {
    $scope.data.categories = LocalService.categories();
    loadLatestNews();
    loadRecentJournals();
  }

  function loadLatestNews() {
    $ionicLoading.show({
      template: '加载中...',
      showBackdrop: true,
    });
    ApiService
      .loadLatestNews()
      .then(function(response) {
        $scope.data.latestNews = response.data.news;
      })
      .catch(function(error) {
      })
      .finally(function() {
        $ionicLoading.hide();
      })
  }

  function loadRecentJournals() {
    ApiService
      .loadRecentJournals({
        pageNo: 1
      })
      .then(function(response) {
        $scope.data.totalPage = response.data.totalPage;
        $scope.data.pageNo = response.data.pageNo;
        $scope.data.recentJournals = response.data.journals;
      })
      .catch(function(response) {
      })
      .finally(function(response) {
      })
  }
})
