angular
.module('gu.controller')
.controller('SearchCtrl', function($scope, $rootScope, $stateParams, $state, $ionicHistory, $ionicLoading, $ionicScrollDelegate, LocalService, ApiService) {
  console.log('搜索页');
  $scope.data = {
    filterIndex: 1,
    keyword: $stateParams.keyword,
    searchResults: {
      news: [],
      journals: []
    },
    searchFinished: true,

    journalTotalPage: 2,
    journalPageNo: 1,
    newsTotalPage: 2,
    newsPageNo: 1,

    firstFilterChange: true
  };

  $rootScope.$on('FOCUS_CLICKED', function(event, data) {
    for (var index = 0; index < $scope.data.searchResults.journals.length; index++) {
      if ($scope.data.searchResults.journals[index].JID == data.journalID)
        break;
    }
    if (index < $scope.data.searchResults.journals.length) {
      if (data.addFlag) {
        $scope.data.searchResults.journals[index].focuses_count ++;
      } else {
        $scope.data.searchResults.journals[index].focuses_count --;
      }
    }
  });

  $rootScope.$on('LIKE_CLICKED', function(event, data) {
    for (var index = 0; index < $scope.data.searchResults.news.length; index++) {
      if ($scope.data.searchResults.news[index].Nid == data.newsID)
        break;
    }
    if (index < $scope.data.searchResults.news.length) {
      if (data.addFlag) {
        $scope.data.searchResults.news[index].likes_count ++;
      } else {
        $scope.data.searchResults.news[index].likes_count --;
      }
    }
  })

  $scope.doRefresh = function() {
    init(1,2);
    $scope.$broadcast('scroll.refreshComplete');
  };

  /*$scope.changeFilter = function(index) {
    if ($scope.data.filterIndex == index) {
      return;
    }
    $scope.data.filterIndex = index;
    $ionicScrollDelegate.$getByHandle('mainScroll').resize();
    if ($scope.data.firstFilterChange) {
     $scope.data.firstFilterChange = false;
     init();
     }
  }*/


  $scope.clearKeyword = function() {
    $scope.data.keyword = '';
    $rootScope.$ionicGoBack();
  }

  $scope.search = function() {
    if (! $scope.data.keyword) {
      $rootScope.$ionicGoBack();
      return;
    }
    /*$scope.data.firstFilterChange = true;*/
    init();
  }

  $scope.loadMoreSearchJournals = function() {
    $scope.data.searchFinished = false;
    ApiService
      .loadSearchJournals({
        keyword: $scope.data.keyword,
        pageNo: $scope.data.journalPageNo + 1
      })
      .then(function(response) {
        $scope.data.journalTotalPage = response.data.totalPage;
        $scope.data.journalPageNo = response.data.pageNo;
        for (var i = 0; i < response.data.journals.length; i++) {
          $scope.data.searchResults.journals.push(response.data.journals[i]);
        }
      })
      .catch(function(response) {
      })
      .finally(function(response) {
        $ionicLoading.hide();
        $scope.data.searchFinished = true;
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })
  }

  $scope.loadMoreSearchNews = function() {
    $scope.data.searchFinished = false;
    ApiService
      .loadSearchNews({
        keyword: $scope.data.keyword,
        pageNo: $scope.data.newsPageNo + 1
      })
      .then(function(response) {
        $scope.data.newsTotalPage = response.data.totalPage;
        $scope.data.newsPageNo = response.data.pageNo;
        for (var i = 0; i < response.data.news.length; i++) {
          $scope.data.searchResults.news.push(response.data.news[i]);
        }
      })
      .catch(function(response) {
      })
      .finally(function(response) {
        $ionicLoading.hide();
        $scope.data.searchFinished = true;
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })
  }

  init();

  function init() {
    $scope.data.searchFinished = false;
    if (1) { // 文章
      $ionicLoading.show({
        template: '加载中...',
        showBackdrop: true,
      });
      ApiService
        .loadSearchNews({
          keyword: $scope.data.keyword,
          pageNo: 1
        })
        .then(function(response) {
          $scope.data.newsTotalPage = response.data.totalPage;
          $scope.data.newsPageNo = response.data.pageNo;
          $scope.data.searchResults.news = response.data.news;
        })
        .catch(function(response) {
        })
        .finally(function(response) {
          $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
          $ionicLoading.hide();
          $scope.data.searchFinished = true;
        })
    }
    if(2){ // 小刊
      $ionicLoading.show({
        template: '加载中...',
        showBackdrop: true,
      });
      ApiService
        .loadSearchJournals({
          keyword: $scope.data.keyword,
          pageNo: 1
        })
        .then(function(response) {
          $scope.data.journalTotalPage = response.data.totalPage;
          $scope.data.journalPageNo = response.data.pageNo;
          $scope.data.searchResults.journals = response.data.journals;
        })
        .catch(function(response) {
        })
        .finally(function(response) {
          $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
          $ionicLoading.hide();
          $scope.data.searchFinished = true;
        })
    }
  }

})
