angular
.module('gu.controller')
.controller('UserFocusCtrl', function($scope, $rootScope, $state, $ionicHistory, $ionicLoading, AuthService, ModalService, ApiService) {
  console.log('我的关注页');
  $scope.data = {
    focusedJournals: [],
    loadingFinished: false,

    totalPage: 1,
    pageNo: 1
  };

  $rootScope.$on('FOCUS_CLICKED', function(event, data) {
    if (data.addFlag) {
      ApiService
        .loadJournal({
          journalID: data.journalID
        })
        .then(function(response) {
          $scope.data.focusedJournals.push(response.data.journal);
        })
        .catch(function(error) {})
    } else {
      for (var index = 0; index < $scope.data.focusedJournals.length; index++)
        if ($scope.data.focusedJournals[index].JID == data.journalID)
          break;
      if (index < $scope.data.focusedJournals.length) {
        $scope.data.focusedJournals[index].focuses_count --;
        $scope.data.focusedJournals.splice(index, 1);
      }
    }
  });

  $scope.doRefresh = function() {
    init();
    $scope.$broadcast('scroll.refreshComplete');
  };

  $scope.goBack = function() {
    $rootScope.$ionicGoBack();
  };

  $scope.loadMore = function() {
    ApiService
      .loadFocusedJournals({
        pageNo: $scope.data.pageNo + 1
      })
      .then(function(response) {
        $scope.data.totalPage = response.data.totalPage;
        $scope.data.pageNo = response.data.pageNo;

        for (var i = 0; i < response.data.focusedJournals.length; i++) {
          $scope.data.focusedJournals.push(response.data.focusedJournals[i]);
        }
      })
      .catch(function(error) {
        if (error.status == 401) { // 已过期， 从新登陆
          AuthService
            .tokenExpired()
            .then(function() {
              ModalService.loginModal.open($rootScope.login);
            })
        }
      })
      .finally(function() {
        $ionicLoading.hide();
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })
  }

  init();

  function init() {
    loadFocusedJournals();
  }

  function loadFocusedJournals() {
    $scope.data.loadingFinished = false;
    $ionicLoading.show({
      template: '加载中...',
      showBackdrop: true,
    });
    ApiService
      .loadFocusedJournals({
        pageNo: 1
      })
      .then(function(response) {
        $scope.data.focusedJournals = response.data.focusedJournals;
        $scope.data.totalPage = response.data.totalPage;
        $scope.data.pageNo = response.data.pageNo;
      })
      .catch(function(error) {
        if (error.status == 401) { // 已过期， 从新登陆
          AuthService
            .tokenExpired()
            .then(function() {
              ModalService.loginModal.open($rootScope.login);
            })
        }
      })
      .finally(function() {
        $scope.data.loadingFinished = true;
        $ionicLoading.hide();
      })
  }
})
