angular
.module('gu.controller')
.controller('UserHeartNewsCtrl', function($scope, $rootScope, $state, $ionicHistory, $ionicLoading, AuthService, ModalService, ApiService) {
  console.log('我的收藏页');
  $scope.data = {
    heartNews: [],
    loadingFinished: false,

    pageNo: 1,
    totalPage: 1
  };

  $rootScope.$on('HEART_CLICKED', function(event, data) {
    if (data.addFlag) {
      ApiService
        .loadNews({
          newsID: data.newsID
        })
        .then(function(response) {
          $scope.data.heartNews.push(response.data.news);
        })
        .catch(function(error) {})
    } else {
      for (var index = 0; index < $scope.data.heartNews.length; index++)
        if ($scope.data.heartNews[index].Nid == data.newsID)
          break;
      $scope.data.heartNews.splice(index, 1);
    }
  });

  $rootScope.$on('LIKE_CLICKED', function(event, data) {
    for (var index = 0; index < $scope.data.heartNews.length; index++) {
      if ($scope.data.heartNews[index].Nid == data.newsID)
        break;
    }

    if (index < $scope.data.heartNews.length) {
      if (data.addFlag) {
        $scope.data.heartNews[index].likes_count ++;
      } else {
        $scope.data.heartNews[index].likes_count --;
      }
    }
  })

  $scope.doRefresh = function() {
    init();
    $scope.$broadcast('scroll.refreshComplete');
  };

  $scope.goBack = function() {
    $rootScope.$ionicGoBack();
  }

  $scope.loadMore = function() {
    ApiService
      .loadHeartNews({
        pageNo: $scope.data.pageNo + 1
      })
      .then(function(response) {
        $scope.data.pageNo = response.data.pageNo;
        $scope.data.totalPage = response.data.totalPage;
        for (var i = 0; i < response.data.heartNews.length; i++) {
          $scope.data.heartNews.push(response.data.heartNews[i]);
        }
      })
      .catch(function(error) {
        if (error.status == 401) { // 已过期， 从新登陆
          AuthService
            .tokenExpired()
            .then(function() {
              ModalService.loginModal.open($rootScope.login);
            })
        }
      })
      .finally(function() {
        $ionicLoading.hide();
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })
  }

  init();

  function init() {
    loadHeartNews();
  }

  function loadHeartNews() {
    $scope.data.loadingFinished = false;
    $ionicLoading.show({
      template: '加载中...',
      showBackdrop: true,
    });
    ApiService
      .loadHeartNews({
        pageNo: 1
      })
      .then(function(response) {
        $scope.data.heartNews = response.data.heartNews;
        $scope.data.pageNo = response.data.pageNo;
        $scope.data.totalPage = response.data.totalPage;
      })
      .catch(function(error) {
        if (error.status == 401) { // 已过期， 从新登陆
          AuthService
            .tokenExpired()
            .then(function() {
              ModalService.loginModal.open($rootScope.login);
            })
        }
      })
      .finally(function() {
        $scope.data.loadingFinished = true;
        $ionicLoading.hide();
      })
  }
})
