angular
.module('gu.controller')
.controller('UserLikeNewsCtrl', function($scope, $rootScope, $state, $ionicHistory, $ionicLoading, AuthService, ModalService, ApiService) {
  console.log('我的点赞页');
  $scope.data = {
    likedNews: [],
    loadingFinished: false,

    pageNo: 1,
    totalPage: 1
  };

  $rootScope.$on('LIKE_CLICKED', function(event, data) {
    if (data.addFlag) {
      ApiService
        .loadNews({
          newsID: data.newsID
        })
        .then(function(response) {
          $scope.data.likedNews.push(response.data.news);
        })
        .catch(function(error) {})
    } else {
      for (var index = 0; index < $scope.data.likedNews.length; index++)
        if ($scope.data.likedNews[index].Nid == data.newsID)
          break;
      $scope.data.likedNews.splice(index, 1);
    }
  })

  $scope.doRefresh = function() {
    init();
    $scope.$broadcast('scroll.refreshComplete');
  };

  $scope.goBack = function() {
    $rootScope.$ionicGoBack();
  }

  $scope.loadMore = function() {
    ApiService
      .loadLikedNews({
        pageNo: $scope.data.pageNo + 1
      })
      .then(function(response) {
        $scope.data.totalPage = response.data.totalPage;
        $scope.data.pageNo = response.data.pageNo;
        for (var i = 0; i < response.data.likedNews.length; i++) {
          $scope.data.likedNews.push(response.data.likedNews[i]);
        }
      })
      .catch(function(error) {
        if (error.status == 401) { // 已过期， 从新登陆
          AuthService
            .tokenExpired()
            .then(function() {
              ModalService.loginModal.open($rootScope.login);
            })
        }
      })
      .finally(function() {
        $ionicLoading.hide();
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })
  }

  init();

  function init() {
    loadLikedNews();
  }

  function loadLikedNews() {
    $scope.data.loadingFinished = false;
    $ionicLoading.show({
      template: '加载中...',
      showBackdrop: true,
    });
    ApiService
      .loadLikedNews({
        pageNo: 1
      })
      .then(function(response) {
        $scope.data.likedNews = response.data.likedNews;
        $scope.data.totalPage = response.data.totalPage;
        $scope.data.pageNo = response.data.pageNo;
      })
      .catch(function(error) {
        if (error.status == 401) { // 已过期， 从新登陆
          AuthService
            .tokenExpired()
            .then(function() {
              ModalService.loginModal.open($rootScope.login);
            })
        }
      })
      .finally(function() {
        $scope.data.loadingFinished = true;
        $ionicLoading.hide();
      })
  }
})
